;
;=========================
; EPROMER fuer KC 85/2   *
;H. Voelz        17.3.87 *
;=========================
;
        ORG     7800H
;
UP      EQU     0F003H
START   EQU     0
ZIEL    EQU     START+2
LAENG   EQU     ZIEL+2
GUT     EQU     LAENG+2
;
;====================
; Werte vorbereiten *
;      Eingabe:     *
; Start, Ende, Ziel *
;====================
AUFB    LD      (START),HL
        LD      (ZIEL),BC
        EX      DE,HL
        OR      A
        SBC     HL,DE
        INC     HL
        LD      (LAENG),HL
;Leerflag
        XOR     A
        LD      (GUT),A
        RET 
;
;=============================:
; setzt Parameter auf Start   *
;=============================:
ANFG    LD      HL,(START)
        LD      DE,(ZIEL)
        LD      BC,(LAENG)
        RET
;
;
;=====================
;  Programmieren     *
;     Start          *
;=====================
        DEFW    7F7FH
        DEFW    'RP'
        DEFB    1
        CALL    AUFB
;12 * 5 Zyklen
        LD      C,12
;Gruppe von 5 Zyklen
PR0     LD      B,5
;Programmieren
PR1     EXX
        CALL    ANFG
        LDIR
        EXX
        DJNZ    PR1-$
        DEC     C
        JR      NZ,VG0-$
;Ende erreicht
        LD      A,(GUT)
        OR      A
        RET     NZ
;fehlerhaft
        CALL    UP
        DEFB    19H ; ERROR
        RET
;
;Test ob Programmiert
VG0     EXX
        CALL    ANFG
VG1     LD      A,(DE)
        CP      (HL)
        JR      NZ,VG2-$
;beide Byte sind gleich
        INC     HL
        INC     DE
        DEC     BC
        LD      A,B
        OR      C
;weiter testen
        JR      NZ,VG1-$
;Gleichheit liegt vor
        EXX
        LD      C,1
        LD      A,C
        LD      (GUT),A
;nur noch einen 5-Zyklus
        JR      PR0-$
;
;noch nicht zu Ende
VG2     EXX
        JR      PR0-$
;
;===================
;   Vergleich      *
;===================
;
        DEFW    7F7FH
        DEFW    'GV'
        DEFB    1
        CALL    AUFB
        CALL    ANFG
VGL     LD      A,(DE)
        CP      (HL)
        CALL    NZ,NICHT
        INC     HL
        INC     DE
        DEC     BC
        LD      A,C
        OR      B
        JR      NZ,VGL-$
        RET
;
;Anzeige:
;Adresse : (DE),(HL)
NICHT   CALL    UP
        DEFB    1AH     ;Adresse
        LD      A,(DE)
        CALL    UP
        DEFB    1CH     ;(DE)
NICHT1  LD      A,':'
        CALL    UP
        NOP
        LD      A,(HL)
        CALL    UP
        DEFB    1CH     ;(HL)
NICHT2  CALL    UP
        DEFB    2CH     ;CRLF
;
;Halt-Routine
;BRK zum Abbruch
;jede andere Taste setzt fort
STP     PUSH    HL
        CALL    UP
        DEFB    4
        CP      3       ;BRK
        JR      NZ,STEND-$
        POP     HL
STEND   POP     HL
        RET
;
;Zeigt Adresse
ZEIGE2  CALL    UP
        DEFB    1AH
        JR      NICHT2-$
;
;
;=========================
;        TEST            *
; Start: Ende: Byte      *
;=========================
;
        DEFW    7F7FH
        DEFW    'ET'
        DEFB    1
        CALL    AUFB
        CALL    ANFG
TE0     LD      A,(HL)
        CP      E
        CALL    NZ,ZEIG
        INC     HL
        DEC     BC
        LD      A,C
        OR      B
        JR      NZ,TE0-$
        RET
;
;Anzeige: Adresse : Byte
ZEIG    CALL    UP
        DEFB    1AH     ;Adresse
        JR      NICHT1-$
;
;========================
;       MOVE            *
; Start: Ende: Ziel     *
;========================
        DEFW    7F7FH
        DEFW    'OM'
        DEFB    1
        CALL    AUFB
;DE= Anfang; BC = Ziel
        EX      DE,HL
        OR      A
        SBC     HL,BC
;CY, wenn Ziel groesser: LDIR
        CALL    ANFG
        JR      C,ABW-$
        LDIR
        RET
;Ziel kleiner
ABW     ADD     HL,BC
        EX      DE,HL
        ADD     HL,BC
        EX      DE,HL
        DEC     HL
        DEC     DE
        LDDR
        RET
;
;=======================
;    Suche  Byte       *
; Start: Ende: Byte    *
;   Anzeige = Adresse  *
;=======================
        DEFW    7F7FH
        DEFW    'SB'
        DEFB    1
        CALL    AUFB
        CALL    ANFG
SB0     LD      A,(HL)
        CP      E
        CALL    Z,ZEIGE2
        INC     HL
        DEC     BC
        LD      A,C
        OR      B
        JR      NZ,SB0-$
        RET
;
;=======================
;   Suche Adresse      *
; Start: Ende: Adresse *
;   Anzeige = Adresse  *
;=======================
        DEFW    7F7FH
        DEFW    'SA'
        DEFB    1
        CALL    AUFB
        CALL    ANFG
AS0     LD      A,(HL)
        CP      E
        INC     HL
        DEC     BC
        LD      A,C
        JR      NZ,AS1-$
;1 Byte OK
        OR      B
        RET     Z
;Vergl. 2. Byte
        LD      A,(HL)
        CP      D
        DEC     HL
        CALL    Z,ZEIGE2
        INC     HL
        JR      AS0-$
;Neues Byte
AS1     OR      B
        RET     Z
        JR      AS0-$
;
;=======================
;  Start eines Programm*
;     ab Adresse       *
;=======================
        DEFW    7F7FH
        DEFW    'OG'
        DEFB    1
        JP      (HL)
;

